<?php
/*
Plugin Name: GoCodes
Plugin URI: http://www.webmaster-source.com/gocodes-redirection-plugin-wordpress/
Description: Create shortcut URLs to anywhere on the internet, right from your Wordpress Admin. When upgrading, be sure to read the <a href="http://wordpress.org/extend/plugins/gocodes/other_notes/">upgrade notes.</a>
Author: Matt Harzewski (redwall_hp)
Author URI: http://www.webmaster-source.com
Version: 1.3.0
*/

//***** What version of WordPress is this? *****
if ($wp_version < "2.7") {
define("GOCODES_URL", "edit.php?page=gocodes/gocodes.php");
}
else {
define("GOCODES_URL", "tools.php?page=gocodes/gocodes.php");
}

//***** Hooks *****
register_activation_hook(__FILE__,'wsc_gocodes_install'); //Install
add_action('init', 'wsc_gocodes_query'); //Redirect
add_action('admin_menu', 'wsc_gocodes_add_pages'); //Admin pages
//***** End Hooks *****


//***** Installer *****
function wsc_gocodes_install() {
//***Installer variables***
global $wpdb;
$table_name = $wpdb->prefix . "wsc_gocodes";
$wsc_gocodes_db_version = "1.1";
//***Installer***
if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
$sql = "CREATE TABLE " . $table_name . " (
	  id mediumint(11) NOT NULL AUTO_INCREMENT,
	  target varchar(255) NOT NULL,
	  key1 varchar(255) NOT NULL,
	  docount int(1) NOT NULL,
	  hitcount mediumint(15) NOT NULL,
	  UNIQUE KEY id (id)
	);";
require_once(ABSPATH . 'wp-admin/upgrade.php');
dbDelta($sql);
$demotarget = "http://www.webmaster-source.com/";
$demokey = "webresources";
$insert = "INSERT INTO " . $table_name . " (target, key1) " . "VALUES ('" . $wpdb->escape($demotarget) . "','" . $wpdb->escape($demokey) . "')";
$results = $wpdb->query( $insert );
add_option("wsc_gocodes_db_version", $wsc_gocodes_db_version);
}
//***Upgrader***
$installed_ver = get_option( "wsc_gocodes_db_version" );
if( $installed_ver != $wsc_gocodes_db_version ) {
$sql = "CREATE TABLE " . $table_name . " (
	  id mediumint(11) NOT NULL AUTO_INCREMENT,
	  target varchar(255) NOT NULL,
	  key1 varchar(255) NOT NULL,
	  docount int(1) NOT NULL,
	  hitcount mediumint(15) NOT NULL,
	  UNIQUE KEY id (id)
	);";
require_once(ABSPATH . 'wp-admin/upgrade.php');
dbDelta($sql);
update_option( "wsc_gocodes_db_version", $wsc_gocodes_db_version );
}
}
//***** End Installer *****

//***** Redirection *****
function wsc_gocodes_query() {
global $wpdb, $table_prefix;
if ($_GET['gocode'] != "") {
$gocode_key = $_GET['gocode'];
$table_name = $wpdb->prefix . "wsc_gocodes";
$gocode_db = $wpdb->get_row("SELECT id, target, key1,docount FROM $table_name WHERE key1 = '$gocode_key'", OBJECT);
$gocode_target = $gocode_db->target;
if ($gocode_target!="") {
if ($gocode_db->docount == 1) {
$update = "UPDATE ". $table_name ." SET hitcount=hitcount+1 WHERE id='$gocode_db->id'";
$results = $wpdb->query( $update );
}
wp_redirect($gocode_target, 301);
exit;
} else{ $badgckey = get_option('siteurl'); header("Location: $badgckey"); exit; }
}
}
//***** End Redirection *****


//Just a boring function to insert the menu
function wsc_gocodes_add_pages () {
add_management_page("GoCodes", "GoCodes", "manage_categories", __FILE__, "wsc_gocodes_managemenu");
}


//***** Menu *****
function wsc_gocodes_managemenu () {
echo '<div class="wrap">';

if ($_GET['editgc'] == "") {

//Add Redirect
if ($_GET['savegc'] == "yes") {
$gckey = $_POST['Key'];
$gctarget = $_POST['Target'];
$gckey = ereg_replace("[^a-zA-Z0-9._-]", "", $gckey );
$gcdocount = $_POST['DoCount'];
if ($gcdocount == "on") { $gcdocount=1; } else { $gcdocount=0; }
if ($gckey!="" && $gctarget!="" && $gctarget!="http://") {
global $wpdb, $table_prefix;
$table_name = $wpdb->prefix . "wsc_gocodes";
$insert = "INSERT INTO " . $table_name . " (target, key1, docount) " . "VALUES ('" . $wpdb->escape($gctarget) . "','" . $wpdb->escape($gckey) . "','". $wpdb->escape($gcdocount) . "')";
$results = $wpdb->query( $insert );
echo '<div id="message" class="updated fade"><p>Redirect added successfully.</p></div>';
} else { echo '<div id="message" class="updated fade"><p>Could not add redirect. You did not properly fill-out both fields!</p></div>'; }
}

//Delete Redirect
if ($_GET['deletegc'] != "") {
$gcid = $_GET['deletegc'];
echo '<div id="message" class="updated fade"><p>Are you sure you want to delete the redirect? <a href="'.GOCODES_URL.'&deletegcconf=yes&gcid='.$gcid.'">Yes</a> &nbsp; <a href="'.GOCODES_URL.'">No!</a></p></div>';
}
if ($_GET['deletegcconf'] != "") {
$gcid = $_GET['gcid'];
global $wpdb, $table_prefix;
$table_name = $wpdb->prefix . "wsc_gocodes";
$wpdb->query("DELETE FROM $table_name WHERE id = '$gcid'");
echo '<div id="message" class="updated fade"><p>Redirect removed successfully.</p></div>';
}

//Uninstall plugin
if ($_GET['uninstallgc'] == "yes") {
echo '<div id="message" class="updated fade"><p><strong>Are you sure you want to delete the GoCodes database entries? You will lose all of your redireccts!</strong><br/><a href="'.GOCODES_URL.'&uninstallgc=yes&confirm=yes">Yes, delete.</a> &nbsp; <a href="index.php">NO!</a></p></div>';
if ($_GET['uninstallgc'] == "yes" && $_GET['confirm'] == "yes") {
global $wpdb, $table_prefix;
$table_name = $wpdb->prefix . "wsc_gocodes";
$uninstallgc = "DROP TABLE ".$table_name;
$results = $wpdb->query( $uninstallgc );
echo '<div id="message" class="updated fade"><p>GoCodes has removed its database entries. Now deactivate the plugin.</p></div>';
return;
}
}

//Update Redirect
if ($_GET['editgcconf'] == "yes") {
$gcpostid = $_POST['id'];
$gcpostkey = $_POST['Key'];
$gcposttarget = $_POST['Target'];
$gcpostdocount = $_POST['DoCount'];
$gcpostkey = ereg_replace("[^a-zA-Z0-9._-]", "", $gcpostkey);
if ($gcpostdocount == "on") { $gcpostdocount=1; } else { $gcpostdocount=0; }
if ($gcpostkey!="" && $gcposttarget!="" && $gcposttarget!="http://") {
global $wpdb, $table_prefix;
$table_name = $wpdb->prefix . "wsc_gocodes";
$insert = "UPDATE $table_name SET target='".$wpdb->escape($gcposttarget)."', key1='".$wpdb->escape($gcpostkey)."', docount='".$wpdb->escape($gcpostdocount)."' WHERE id=$gcpostid";
$results = $wpdb->query( $insert );
echo '<div id="message" class="updated fade"><p>Redirect saved successfully.</p></div>';
}
else { echo '<div id="message" class="updated fade"><p>Could not update redirect. You did not properly fill-out a field!</p></div>'; }
}

//Reset Redirect Counter
if ($_GET['gcresetcount'] == "yes") {
$gcid = $_GET['gcid'];
echo '<div id="message" class="updated fade"><p>Are you sure you want to reset the hit count for the redirect? <a href="'.GOCODES_URL.'&gcresetcountconf=yes&gcid='.$gcid.'">Yes</a> &nbsp; <a href="'.GOCODES_URL.'">No!</a></p></div>';
}
if ($_GET['gcresetcountconf'] == "yes") {
$gcid = $_GET['gcid'];
global $wpdb, $table_prefix;
$table_name = $wpdb->prefix . "wsc_gocodes";
$insert = "UPDATE $table_name SET hitcount=0 WHERE id=$gcid";
$results = $wpdb->query( $insert );
}


//Form
echo "<h2>Add GoCode</h2>";
echo '<div>';
echo '<form method="post" action="'.GOCODES_URL.'&savegc=yes">';
echo '<table class="form-table">';
echo '<tr class="form-field form-required">';
echo '<th scope="row" valign="top"><label for="Key">Redirection Key</label></th>';
echo '<td><input type="text" name="Key" value="" />';
echo ' <br />The text after /go/ that triggers the redirect (e.g. yourblog.com/go/thekey/).</td>';
echo '</tr>';
echo '<tr class="form-field form-required">';
echo '<th scope="row" valign="top"><label for="Target">Target URL</label></th>';
echo '<td><input type="text" name="Target" value="http://" />';
echo ' <br />The URL you wish to redirect to. "http://" is required.</td>';
echo '</tr>';
echo '<tr class="form-field form-required">';
echo '<th scope="row" valign="top"><label for="DoCount">Count hits?</label></th>';
echo ' <td><input type="checkbox" name="DoCount" /> Yes, track the number of times this redirect is used.</td>';
echo '</tr>';
echo '</table>';
echo ' <p class="submit"><input type="submit" name="Submit" class="button" value="Add Redirect" /></p>';
echo '</form>';
echo '<br/><br/>';
echo '</div>';

//List
echo "<h2>Manage GoCodes</h2><br />";
echo '<div>';
echo '<table class="widefat">';
echo '<thead>';
echo '<tr>';
echo '<th scope="col"><div style="text-align: center">Key</div></th>';
echo '<th scope="col"><div style="text-align: center">Target</div></th>';
echo '<th scope="col"><div style="text-align: center">Hits</div></th>';
echo '<th scope="col"></th>';
echo '<th scope="col"></th>';
echo '</tr>';
echo '</thead>';
echo '<tbody id="the-list">';

global $wpdb, $table_prefix;
$table_name = $wpdb->prefix . "wsc_gocodes";
$gocodes = $wpdb->get_results("SELECT id, target, key1, docount, hitcount FROM $table_name WHERE key1 != '' ORDER BY id DESC", OBJECT);
$basewpurl = get_option('siteurl');
if ($gocodes):
foreach ($gocodes as $gocode):
if($gocode->docount != 1) { $gocode->hitcount = ""; }
echo '<tr class="alternate"> <td><strong>'.$gocode->key1.'</strong><br /><small>'.$basewpurl.'/go/'.$gocode->key1.'/</small></td> <td>'.wsc_gocodes_truncate($gocode->target).'</td> <td style="text-align: center">'.$gocode->hitcount.'</td> <td><a href="'.GOCODES_URL.'&editgc='.$gocode->id.'">Edit</a></td> <td><a href="'.GOCODES_URL.'&deletegc='.$gocode->id.'" class="delete">Delete</a></td> </tr>';
endforeach; 
else : 
echo "Not Found";
endif; 

echo '</tbody>';
echo '</table>';
echo '</div>';

}

if ($_GET['editgc'] != "") {
$gcid = $_GET['editgc'];
global $wpdb, $table_prefix;
$table_name = $wpdb->prefix . "wsc_gocodes";
$editquery = "SELECT id, target, key1, docount, hitcount FROM $table_name WHERE id=$gcid";
$gocode = $wpdb->get_row($editquery, OBJECT);
echo '<div class="wrap">';
echo "<h2>Edit GoCode</h2>";
echo '<div>';
echo '<form method="post" action="'.GOCODES_URL.'&editgcconf=yes">';
echo '<table class="form-table">';
echo '<table class="form-table">';
echo '<tr class="form-field form-required">';
echo '<th scope="row" valign="top"><label for="Key">Redirection Key</label></th>';
echo '<td><input type="text" name="Key" value="'.$gocode->key1.'" />';
echo ' The text after /go/ that triggers the redirect (e.g. yourblog.com/go/thekey/).</td>';
echo '</tr>';
echo '<tr class="form-field form-required">';
echo '<th scope="row" valign="top"><label for="Target">Target URL</label></th>';
echo '<td><input type="text" name="Target" value="'.$gocode->target.'" />';
echo ' The URL you wish to redirect to. "http://" is required.</td>';
echo '</tr>';
echo '<tr class="form-field form-required">';
echo '<th scope="row" valign="top"><label for="DoCount">Count hits?</label></th>';
echo ' <td><input type="checkbox" name="DoCount"'; if($gocode->docount==1) { echo 'checked="checked"'; } echo '/> Yes, track the number of times this redirect is used. &nbsp;&nbsp; <a href="'.GOCODES_URL.'&gcresetcount=yes&gcid='.$gcid.'">Reset count</a></td>';
echo '</tr>';
echo '</table>';
echo ' <input type="hidden" name="id" value="'.$gcid.'" />';
echo ' <p class="submit"><input type="submit" name="Submit" class="button" value="Edit Redirect" /></p>';
echo '</form>';
echo '</div>';
echo '</div>';
}


echo '</div>';
}
//***** End Menu *****


//***** GoCode Box *****
function wsc_gocodes_form () {
//This function doesn't do anything yet
return;
}
//***** End GoCode Box *****


function wsc_gocodes_truncate($text) {
if ( strlen($text) > 79 ) {
$text = $text." ";
$text = substr($text,0,80);
$text = $text."...";
return $text;
} else { return $text; }
}


/*
Copyright 2008 Matt Harzewski

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

?>